package engine;
import flash.display.BitmapData;

/**
 * ...
 * @author randomnine
 */

class GameSceneManager 
{
	var m_currentScene : GameScene;
	var m_newScene : GameScene;

	public function new( _scene:GameScene ) 
	{
		m_currentScene = _scene;
		m_currentScene.activate();
		
		m_newScene = null;
	}
	
	public function changeScene( _newScene:GameScene )
	{
		m_newScene = _newScene;
	}
	
	public function advance( _dt:Float, _context:AdvanceContext )
	{
		// Change scene?
		if ( m_newScene != null )
		{
			m_currentScene.deactivate();
			
			m_currentScene = m_newScene;
			m_currentScene.activate();
			
			m_newScene = null;
		}
		
		// Advance the new scene.
		_context.m_sceneManager = this;
		m_currentScene.advance( _dt, _context );
	}
	
	public function render( _targetBD:BitmapData )
	{
		m_currentScene.render( _targetBD );
	}
}