package game.data;

import flash.display.BitmapData;
import flash.geom.ColorTransform;

import engine.FontSheet;

class ImgFont extends BitmapData {public function new(){super(0,0);}}

/**
 * ...
 * @author randomnine
 */

class FontData 
{
	// Singleton. -------------------------------------------------------------
	private static var s_singleton:FontData = null;
	
	public static function get() : FontData
	{
		if ( s_singleton == null )
		{
			s_singleton = new FontData();
		}
		
		return s_singleton;
	}
	
	// Object. ----------------------------------------------------------------
	var m_fontSheet:FontSheet;
	var m_greyFontSheet:FontSheet;
	var m_goldFontSheet:FontSheet;
	var m_blackFontSheet:FontSheet;
	
	public function new() 
	{
		var fontBD:BitmapData = new ImgFont();
		
		m_fontSheet = new FontSheet( fontBD, 8, 8, -1, 4 );

		var greyFontBD:BitmapData = fontBD.clone();
		var cTransform:ColorTransform = new ColorTransform( 0.5, 0.5, 0.5 );
		greyFontBD.colorTransform( greyFontBD.rect, cTransform );
		
		m_greyFontSheet = new FontSheet( greyFontBD, 8, 8, -1, 4 );
		
		var goldFontBD:BitmapData = fontBD.clone();
		var cTransform:ColorTransform = new ColorTransform( 1.0, 0.98, 0.4 );
		goldFontBD.colorTransform( goldFontBD.rect, cTransform );
		
		m_goldFontSheet = new FontSheet( goldFontBD, 8, 8, -1, 4 );

		var blackFontBD:BitmapData = fontBD.clone();
		var cTransform:ColorTransform = new ColorTransform( 0.0, 0.0, 0.0 );
		blackFontBD.colorTransform( blackFontBD.rect, cTransform );
		
		m_blackFontSheet = new FontSheet( blackFontBD, 8, 8, -1, 4 );
	}

	public function getFont() : FontSheet { return m_fontSheet; }
	public function getGreyFont() : FontSheet { return m_greyFontSheet; }
	public function getGoldFont() : FontSheet { return m_goldFontSheet; }
	public function getBlackFont() : FontSheet { return m_blackFontSheet; }
}
