package game.scenes;

import flash.display.BitmapData;
import flash.external.ExternalInterface;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.Lib;

import engine.AdvanceContext;
import engine.FontSheet;
import engine.GameInput;
import engine.GameScene;

import game.data.FontData;

/**
 * ...
 * @author randomnine
 */

class ScenePreloader implements GameScene
{
	var m_progress : Float;
	
	public function new() 
	{
		m_progress = 0.0;
	}

	public function activate()
	{
	}
	
	public function deactivate()
	{
	}
	
	public function advance( _dt:Float, _context:AdvanceContext ) : Void
	{
		if ( m_progress < 0 ) { 
			return;
		}
		
		if ( _context.m_main.isDownloadComplete() )
		{
			m_progress = 1.1;
			
			_context.m_main.setAllowPause(true);

			_context.m_sceneManager.changeScene( new SceneSnake() );
		}
		else
		{
			m_progress = _context.m_main.getDownloadProgress();
		}
	}
	
	public function render( _targetBD:BitmapData ) : Void
	{
		if ( m_progress < 0 ) { 
			return;
		}
		
		_targetBD.fillRect( _targetBD.rect, 0x000000 );
		
		var barY:Int = 115;
		
		if ( m_progress > 1.09 )
		{
			_targetBD.fillRect( _targetBD.rect, 0x000000 );
			
			_targetBD.fillRect( new Rectangle( 48, barY+1, 103, 8 ), 0x404040 );
			_targetBD.fillRect( new Rectangle( 49, barY+2, 101, 6 ), 0x000000 );
			_targetBD.fillRect( new Rectangle( 50, barY+3, 99, 4 ), 0x404040 );
			_targetBD.fillRect( new Rectangle( 86, barY+0, 27, 10 ), 0x000000 );
		}
		else
		{
			_targetBD.fillRect( _targetBD.rect, 0x000000 );

			_targetBD.fillRect( new Rectangle( 48, barY+1, 103, 8 ), 0x808080 );
			_targetBD.fillRect( new Rectangle( 49, barY+2, 101, 6 ), 0x000000 );
			_targetBD.fillRect( new Rectangle( 50, barY+3, 99 * m_progress, 4 ), 0xFFFFFF );
		}
	}
}
